> For the complete documentation index, see [llms.txt](https://docs.movesdk.com/move-platform/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.movesdk.com/move-platform/move-sdk-1.x/sdk/models/moveconfig.md).

# MoveConfig

The SDK offers to detect different modes of transport and driving services. The host app can configure which driving services to activate and modes of transport to detect by setting the [MoveConfig](/move-platform/move-sdk-1.x/sdk/models/moveconfig.md) object when initializing the SDK.

{% hint style="warning" %}
**The host app must only configure its SDK services to the set or subset of services subscribed** by the SDK product id of this host app. The SDK initialization will fail and complete with [MoveConfigurationError](/move-platform/move-sdk-1.x/sdk/models/moveconfigurationerror.md)`.configMismatch` otherwise.
{% endhint %}

{% tabs %}
{% tab title="Android" %}

```
Android does not provide a config object, 
but uses various Move.Builder methods for this

   enum TimelineDetectionService {
        case DRIVING
        case BICYCLE
        case WALKING
        case PLACES
        case PUBLIC_TRANSPORT
    }
     
    enum DrivingService {
        case DistractionFreeDriving
        case DrivingBehaviour
    }
 
    enum OtherService {
	case PointsOfInterest
     }
```

{% endtab %}

{% tab title="iOS" %}

```swift
struct MoveConfig {
    enum TimelineDetectionService {
        case driving
        case bicycle
        case walking
        case places
        case publicTransport
    }
     
    enum DrivingService {
        case dfd
        case behaviour
    }
 
    enum OtherService: Int, Codable {
        case poi
    }
 
    var timelineDetectionServices: [TimelineDetectionService]
    var drivingServices: [DrivingService]
    var otherServices: [OtherService]
}
```

{% endtab %}

{% tab title="React Native" %}

```javascript
export type RnDolphinConfig = {
  modesOfTransport: ModeOfTransport[],
  drivingServices: DrivingService[],
  walkingServices: WalkingService[],
  otherServices: OtherService[],
};

export type DrivingService = 'DistractionFreeDriving' | 'DrivingBehaviour';
export type WalkingService = 'Location';
export type OtherService = 'POI';
export type ModeOfTransport = 'DRIVING' | 'BICYCLE' | 'WALKING';
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
For Android check the [Initialization ](/move-platform/move-sdk-1.x/sdk/api-interface/android-1/builder.md)page
{% endhint %}

| MoveConfig                    |                 |                                                                    |
| ----------------------------- | --------------- | ------------------------------------------------------------------ |
| **TimelineDetectionServices** |                 | List of required modes of transportation to be detected.           |
|                               | driving         | Detect the driving activity.                                       |
|                               | bicycle         | Detect the cycling activity.                                       |
|                               | walking         | Detect the walking activity.                                       |
|                               | places          | Detect places where user spent time.                               |
|                               | publicTransport | Detect public transport trips                                      |
| **DrivingServices**           |                 | List of required driving services to be detected.                  |
|                               | dfd             | Detect the user's distraction-free driving duration during a trip. |
|                               | behavior        | Detect the user's driving behavior during a trip.                  |
| **OtherServices**             |                 | Other SDK services                                                 |
|                               | poi             | Monitor and track points of interest                               |

{% hint style="info" %}
Each [MoveConfig](/move-platform/move-sdk-1.x/sdk/models/moveconfig.md) requires one or more permissions (see for [Android](/move-platform/move-sdk-1.x/sdk/appendix/android/permission-handling.md) and [iOS](/move-platform/move-sdk-1.x/sdk/appendix/ios/permission-handling.md)). **The SDK services will not start and**[ **MoveSDKState**](/move-platform/move-sdk-1.x/sdk/models/movestate.md) **will transit to`.permissionMissing`error state in case one or more required permissions were missing.** Check [MoveSDKState](/move-platform/move-sdk-1.x/sdk/models/movestate.md) for more details.
{% endhint %}

| MoveConfig-related APIs                                                                               |                                                                                  |
| ----------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------- |
| [Move.Sdk.Builder](/move-platform/move-sdk-1.x/sdk/api-interface/android-1/builder.md) (A)            | Android does not provide a config object, but uses the Builder methods for this. |
| [Initialization](/move-platform/move-sdk-1.x/sdk/api-interface/ios/intialization.md#definition) (iOS) | Pass the required configurations on intialization.                               |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.movesdk.com/move-platform/move-sdk-1.x/sdk/models/moveconfig.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
